/* ---------------------------------------------------------------------- */
/* Script generated with: DeZign for Databases v5.2.0                     */
/* Target DBMS:           Oracle 10g                                      */
/* Project file:          ordbanken_sprkbanken.dez                       */
/* Project name:                                                          */
/* Author:                                                                */
/* Script type:           Database creation script                        */
/* Created on:            2011-09-21 14:19                                */
/* Model version:         Version 2011-09-21                              */
/* ---------------------------------------------------------------------- */


/* ---------------------------------------------------------------------- */
/* Tables                                                                 */
/* ---------------------------------------------------------------------- */

/* ---------------------------------------------------------------------- */
/* Add table "LEMMA"                                                      */
/* ---------------------------------------------------------------------- */

CREATE TABLE LEMMA (
    LEMMA_ID NUMBER(8) CONSTRAINT NN_LEMMA_ID NOT NULL,
    GRUNNFORM VARCHAR2(100) CONSTRAINT NN_GRUNNFORM NOT NULL,
    CONSTRAINT I01_LEMMA PRIMARY KEY (LEMMA_ID)
);

/* ---------------------------------------------------------------------- */
/* Add table "BOYING_GRUPPER"                                             */
/* ---------------------------------------------------------------------- */

CREATE TABLE BOYING_GRUPPER (
    BOY_GRUPPE VARCHAR2(20) CONSTRAINT NN_BOY_GRUPPE NOT NULL,
    CONSTRAINT I01_BOYING_GRUPPER PRIMARY KEY (BOY_GRUPPE)
);

/* ---------------------------------------------------------------------- */
/* Add table "BOYING"                                                     */
/* ---------------------------------------------------------------------- */

CREATE TABLE BOYING (
    BOY_NUMMER NUMBER(2) CONSTRAINT NN_BOY_NUMMER NOT NULL,
    BOY_GRUPPE VARCHAR2(20) CONSTRAINT NN_BOY_GRUPPE NOT NULL,
    BOY_TEKST VARCHAR2(100),
    CONSTRAINT I01_BOYING PRIMARY KEY (BOY_NUMMER, BOY_GRUPPE)
);

CREATE INDEX BOYING_GRUPPER_BOYING ON BOYING (BOY_GRUPPE);

/* ---------------------------------------------------------------------- */
/* Add table "FULLFORMSLISTE"                                             */
/* ---------------------------------------------------------------------- */

CREATE TABLE FULLFORMSLISTE (
    LEMMA_ID NUMBER(8) CONSTRAINT NN_LEMMA_ID NOT NULL,
    OPPSLAG VARCHAR2(100) CONSTRAINT NN_OPPSLAG NOT NULL,
    TAG VARCHAR2(1000) CONSTRAINT NN_TAG NOT NULL,
    PARADIGME_ID VARCHAR2(5) CONSTRAINT NN_PARADIGME_ID NOT NULL,
    BOY_NUMMER NUMBER(2) CONSTRAINT NN_BOY_NUMMER NOT NULL,
    FRADATO VARCHAR2(10) DEFAULT '1996' CONSTRAINT NN_FRADATO NOT NULL,
    TILDATO VARCHAR2(10) DEFAULT '4000' CONSTRAINT NN_TILDATO NOT NULL,
    CONSTRAINT I01_FULLFORMSLISTE PRIMARY KEY (LEMMA_ID, OPPSLAG, TAG, PARADIGME_ID, BOY_NUMMER)
);

CREATE INDEX FULLFORMLISTE_OPPSLAG ON FULLFORMSLISTE (OPPSLAG);

CREATE INDEX INDEX_FULLFORMSLISTE_FRADATO ON FULLFORMSLISTE (FRADATO);

CREATE INDEX INDEX_FULLFORMSLISTE_TILDATO ON FULLFORMSLISTE (TILDATO);

CREATE INDEX LEMMA_FULLFORMSLISTE ON FULLFORMSLISTE (LEMMA_ID);

/* ---------------------------------------------------------------------- */
/* Add table "PARADIGME"                                                  */
/* ---------------------------------------------------------------------- */

CREATE TABLE PARADIGME (
    PARADIGME_ID VARCHAR2(5) CONSTRAINT NN_PARADIGME_ID NOT NULL,
    BOY_GRUPPE VARCHAR2(20) CONSTRAINT NN_BOY_GRUPPE NOT NULL,
    ORDKLASSE VARCHAR2(50) CONSTRAINT NN_ORDKLASSE NOT NULL,
    ORDKLASSE_UTDYPING VARCHAR2(100),
    FORKLARING VARCHAR2(100),
    DOEME VARCHAR2(100),
    ID NUMBER(5) CONSTRAINT NN_ID NOT NULL,
    CONSTRAINT I01_PARADIGME PRIMARY KEY (PARADIGME_ID),
    CONSTRAINT PARADIGME_ID_UNIQUE UNIQUE (ID)
);

CREATE INDEX BOYING_GRUPPER_PARADIGME ON PARADIGME (BOY_GRUPPE);

/* ---------------------------------------------------------------------- */
/* Add table "LEMMA_PARADIGME"                                            */
/* ---------------------------------------------------------------------- */

CREATE TABLE LEMMA_PARADIGME (
    LEMMA_ID NUMBER(8) CONSTRAINT NN_LEMMA_ID NOT NULL,
    PARADIGME_ID VARCHAR2(5) CONSTRAINT NN_PARADIGME_ID NOT NULL,
    NORMERING VARCHAR2(20) DEFAULT 'normert' CONSTRAINT NN_NORMERING NOT NULL,
    FRADATO VARCHAR2(10) CONSTRAINT NN_FRADATO NOT NULL,
    TILDATO VARCHAR2(10) CONSTRAINT NN_TILDATO NOT NULL,
    CONSTRAINT PK_LEMMA_PARADIGME PRIMARY KEY (LEMMA_ID, PARADIGME_ID, NORMERING, FRADATO, TILDATO)
);

CREATE INDEX LEMMA_LEMMA_PARADIGME ON LEMMA_PARADIGME (LEMMA_ID);

CREATE INDEX PARADIGME_LEMMA_PARADIGME ON LEMMA_PARADIGME (PARADIGME_ID);

/* ---------------------------------------------------------------------- */
/* Add table "PARADIGME_BOYING"                                           */
/* ---------------------------------------------------------------------- */

CREATE TABLE PARADIGME_BOYING (
    PARADIGME_ID VARCHAR2(5) CONSTRAINT NN_PARADIGME_ID NOT NULL,
    BOY_NUMMER NUMBER(2) CONSTRAINT NN_BOY_NUMMER NOT NULL,
    BOY_GRUPPE VARCHAR2(20) CONSTRAINT NN_BOY_GRUPPE NOT NULL,
    BOY_UTTRYKK VARCHAR2(50),
    CONSTRAINT I01_PARADIGME_BOYING PRIMARY KEY (PARADIGME_ID, BOY_NUMMER, BOY_GRUPPE)
);

CREATE INDEX BOYING_PARADIGME_BOYING ON PARADIGME_BOYING (BOY_NUMMER,BOY_GRUPPE);

CREATE INDEX PARADIGME_PARADIGME_G ON PARADIGME_BOYING (PARADIGME_ID);

/* ---------------------------------------------------------------------- */
/* Foreign key constraints                                                */
/* ---------------------------------------------------------------------- */

ALTER TABLE BOYING ADD CONSTRAINT BOYING_GRUPPER_BOYING 
    FOREIGN KEY (BOY_GRUPPE) REFERENCES BOYING_GRUPPER (BOY_GRUPPE);

ALTER TABLE FULLFORMSLISTE ADD CONSTRAINT LEMMA_FULLFORMSLISTE 
    FOREIGN KEY (LEMMA_ID) REFERENCES LEMMA (LEMMA_ID) ON DELETE CASCADE;

ALTER TABLE PARADIGME ADD CONSTRAINT BOYING_GRUPPER_PARADIGME 
    FOREIGN KEY (BOY_GRUPPE) REFERENCES BOYING_GRUPPER (BOY_GRUPPE);

ALTER TABLE LEMMA_PARADIGME ADD CONSTRAINT LEMMA_LEMMA_PARADIGME 
    FOREIGN KEY (LEMMA_ID) REFERENCES LEMMA (LEMMA_ID) ON DELETE CASCADE;

ALTER TABLE LEMMA_PARADIGME ADD CONSTRAINT PARADIGME_LEMMA_PARADIGME 
    FOREIGN KEY (PARADIGME_ID) REFERENCES PARADIGME (PARADIGME_ID);

ALTER TABLE PARADIGME_BOYING ADD CONSTRAINT BOYING_PARADIGME_BOYING 
    FOREIGN KEY (BOY_NUMMER, BOY_GRUPPE) REFERENCES BOYING (BOY_NUMMER,BOY_GRUPPE);

ALTER TABLE PARADIGME_BOYING ADD CONSTRAINT PARADIGME_PARADIGME_G 
    FOREIGN KEY (PARADIGME_ID) REFERENCES PARADIGME (PARADIGME_ID);
